import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import java.util.*;

/* This parses the config file */
public class ConfigHandler extends DefaultHandler {
	private boolean inImages = false;
	private boolean inImage = false;
	private boolean inImageTitle = false;
	private boolean inImagePath = false;
	private boolean inImageLocation = false;
	String ImagePath = "";
	static String ImageLocation = "";
	
	Vector ImagePaths = new Vector();
	
	static Vector AllImagePaths = new Vector(); 
	
	Display MainDisplay;
	
	String ImageTitle = "";
	
	public void startElement(String namespaceURI, String localName,
				String qualifiedName, Attributes atts) throws SAXException {
	    if (qualifiedName.equals("Images")) inImages = true;
    	if (qualifiedName.equals("Image")) inImage = true;
    	if (qualifiedName.equals("ImageTitle")) inImageTitle = true;
    	if (qualifiedName.equals("ImagePath")) inImagePath = true;
    	if (qualifiedName.equals("ImageLocation")) inImageLocation = true;
    }

	public void endElement(String namespaceURI, String localName,
   				String qualifiedName) throws SAXException {

    	if (qualifiedName.equals("Images")) {
    		String[] Paths = new String[ImagePaths.size() + 1];
			inImages = false;
    		int i = 0;
     		Paths[i++] = ImageTitle;
			for (Enumeration e = ImagePaths.elements(); e.hasMoreElements();) {
				Paths[i++] = ImagePath + (String) e.nextElement();
			}
			AllImagePaths.add(Paths);
			ImagePaths.clear();
			ImageTitle = "";
			ImagePath = "";
		}
    	if (qualifiedName.equals("Image")) inImage = false;
    	if (qualifiedName.equals("ImageTitle")) inImageTitle = false;
    	if (qualifiedName.equals("ImagePath")) inImagePath = false;
    	if (qualifiedName.equals("ImageLocation")) {
    		inImageLocation = false;
   		}
	}
	
	public void characters(char[] ch, int start, int length)
								throws SAXException {
		String s = "";
		if (inImage) {
			for (int i = start; i < start + length; i++) {
				if ((ch[i] != '\t') && (ch[i] != '\r') && (ch[i] != '\n')) {
					s += ch[i];
				}
			}
			if (!s.equals("")) {
				/* trim gets rid of leading and trailing spaces */
				ImagePaths.add(s.trim());
			}
		}	  
		if (inImageTitle) {
			for (int i = start; i < start + length; i++) {
				if ((ch[i] != '\t') && (ch[i] != '\r') && (ch[i] != '\n')) {
					s += ch[i];
				}
			}
			if (!s.equals("")) {
				ImageTitle = s.trim();
			}
		}
		if (inImagePath) {
			for (int i = start; i < start + length; i++) {
				if ((ch[i] != '\t') && (ch[i] != '\r') && (ch[i] != '\n')) {
					s += ch[i];
				}
			}
			if (!s.equals("")) {
				ImagePath = s.trim();
			}
		}
		if (inImageLocation) {
			for (int i = start; i < start + length; i++) {
				if ((ch[i] != '\t') && (ch[i] != '\r') && (ch[i] != '\n')) {
					s += ch[i];
				}
			}
			if (!s.equals("")) {
				ImageLocation = s.trim();
			}
		}
	}
}
