import java.util.*;
import java.io.*;

/* Implement a very basic database, with just add, delete and select functions */
public class Database {
	private static Vector Puzzles = new Vector();
	private static final int cols = 3;
	private static File DatabaseFile;
	
	public static void add(Vector P) {
		Puzzles.addAll(P);	
	}
	
	public static int length() {
		return Puzzles.size();
	}
	
	public static String[][] getDatabaseEntries() {
		String[][] rows = new String[Puzzles.size()][];
		for (int i = 0; i < Puzzles.size(); i++) {
			rows[i] = new String[cols];
			rows[i][0] = ((Puzzle) Puzzles.get(i)).getType();
			rows[i][1] = ((Puzzle) Puzzles.get(i)).getSource();
			rows[i][2] = ((Puzzle) Puzzles.get(i)).getDifficulty();
		}
		return rows;
	}
	
	public static Puzzle getPuzzle(int Index) {
		return (Puzzle) Puzzles.get(Index);
	}
	
	public static void removePuzzle(int Index) {
		Puzzles.remove(Index);
	}
	
	public static void addPuzzle(Puzzle P) {
		Puzzles.add(P);
	}
	
	public static void setFile(File F) {
		DatabaseFile = F;
	}
	
	/* Writes the whole database anew when changes are made. Very inefficient, but easy
		to implement */
	public static void saveDatabase() {
		if (DatabaseFile != null) {
			try {
				PrintWriter pw = new PrintWriter(new FileWriter(DatabaseFile, false));
				pw.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
				pw.println("<Database>");
				for (Enumeration e = Puzzles.elements(); e.hasMoreElements() ;) {
					((Puzzle) e.nextElement()).saveToFile(pw);
				}
				pw.println("</Database>");
				
				pw.flush();
				pw.close();	
			}
			catch (IOException ioe) {
			}
		}
	}
}