import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.util.*;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

/* This is the interface to control the database */
/* Most of it is pinched from a website and then modified so I'm not entirely sure what it does */
class DatabasePanel extends JPanel {
	JTable table;
	DatabaseScreen DS;
	DatabaseTable DT;
	
	public DatabasePanel(int rows, DatabaseScreen Owner) {
        super(new GridLayout(1,0));

		DS = Owner;
		DT = new DatabaseTable(rows);
        table = new JTable(DT);
        table.setPreferredScrollableViewportSize(new Dimension(500, 70));
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
		ListSelectionModel rowSM = table.getSelectionModel();
		rowSM.addListSelectionListener(DatabaseListener);

        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);

        //Add the scroll pane to this panel.
        add(scrollPane);
    }

	ListSelectionListener DatabaseListener = new ListSelectionListener() {
		public void valueChanged(ListSelectionEvent e) {
			if (e.getValueIsAdjusting()) return;

			ListSelectionModel lsm =
				(ListSelectionModel)e.getSource();
			if (lsm.isSelectionEmpty()) {
			} else {
				int selectedRow = lsm.getMinSelectionIndex();
				if (((Boolean) table.getValueAt(selectedRow, 3)).booleanValue() == true) {
					DT.removeRow(selectedRow);
				} else {
					DS.setPuzzle(selectedRow);
				}
			}
		}
	};
	
	public void setValues(String[][] Values) {
		for (int i = 0; i < Values.length; i++) {
			for (int j = 0; j < Values[i].length; j++) {
				table.setValueAt(Values[i][j], i, j);
			}
			table.setValueAt(new Boolean(false), i, 3);
		}
	}

	class DatabaseTable extends AbstractTableModel{
		private String[] columnNames = {"Type","Source", "Difficulty", "Delete"};
		private Object[][] data;
		private final int cols = 4;
	
		public DatabaseTable(int rows) {
			super();
			data = new Object[rows][];
			for (int i = 0; i < rows; i++) {
				data[i] = new Object[cols];
			}
		}
	
		public String getColumnName(int col) {
			return columnNames[col].toString();
		}
		
		public int getRowCount() { return data.length; }
		
		public int getColumnCount() { return columnNames.length; }
		
		public Object getValueAt(int row, int col) {
			return data[row][col];
		}
	
		public Class getColumnClass(int c) {
        	return getValueAt(0, c).getClass();
    	}
    	
    	public void removeRow(int row) {
    		Object[][] TempData;
    		int rows = data.length;
    		int offset = 0;
    		TempData = new Object[rows - 1][];
    		for (int i = 0; i < rows - 1; i++) {
				TempData[i] = new Object[cols];
			}		
			for (int i = 0; i < rows; i++) {
				if (i == row) offset = 1;
				if (i != row) {
					for (int j = 0; j < cols; j++) {
						TempData[i - offset][j] = data[i][j];
					}
				}
			}
			data = TempData;
			fireTableRowsDeleted(row, row);
    	}
    	
		public boolean isCellEditable(int row, int col) { 
			if (col < 3) {
				return false; 
			} else return true;
		}
			
		public void setValueAt(Object value, int row, int col) {
			data[row][col] = value;
			fireTableCellUpdated(row, col);
		}
	}
}

public class DatabaseScreen {
	JFrame DatabaseFrame;
	MainPanel MP;
	
	public DatabaseScreen(MainPanel Owner) {
		MP = Owner;
		DatabasePanel CentrePanel = new DatabasePanel(Database.length(), this);
		CentrePanel.setValues(Database.getDatabaseEntries());
		DatabaseFrame = new JFrame();
		DatabaseFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		DatabaseFrame.getContentPane().add(CentrePanel);
		DatabaseFrame.pack();	
	
		DatabaseFrame.setVisible(true);	
	}
	
	public void setPuzzle(int Index) {
		MP.addPuzzle(Database.getPuzzle(Index), false);
	}
}