import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.nio.channels.FileChannel;

/* This allows the user to enter their own images */
class GetImagePanel extends JPanel 
					implements ActionListener {
	JButton FileButton;
	JTextField FileTF;
	File sf;
	
	/* One of these per image to be entered */
	public GetImagePanel() {
		setLayout(new GridLayout(1,2));
		FileTF = new JTextField();
		add(FileTF);
		FileButton = new JButton("Select");
		add(FileButton);
		FileButton.addActionListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		JFileChooser chooser = new JFileChooser();
		int option = chooser.showOpenDialog(this);
	
		if (option == JFileChooser.APPROVE_OPTION) {
			sf = chooser.getSelectedFile();
			FileTF.setText(sf.getPath());
		}
	}
	
	/* Returns the text rather than the file selected incase changes have been made to the text */
	public File getSelectedFile() {
		return new File(FileTF.getText());
	}
}

public class EnterImages implements ActionListener {
	JFrame EnterFrame;
	JButton OKButton;
	JButton CancelButton;
	GetImagePanel[] GIP;
	JTextField TitleTE;
	Display MainDisplay;
	
	public EnterImages(int NumOfImages, Display D) {
		super();
		MainDisplay = D;
		JPanel EnterPanel = new JPanel();
		EnterPanel.setLayout(new GridLayout(NumOfImages + 2, 1));
		
		JPanel TitlePanel = new JPanel();
		TitlePanel.setLayout(new GridLayout(1,2));
		
		JLabel TitleLabel = new JLabel("Title");
		TitleTE = new JTextField("");
		TitlePanel.add(TitleLabel);
		TitlePanel.add(TitleTE);
		EnterPanel.add(TitlePanel);
		
		JPanel ButtonPanel = new JPanel();
		ButtonPanel.setLayout(new BoxLayout(ButtonPanel, BoxLayout.X_AXIS));
		OKButton = new JButton("OK");
		OKButton.addActionListener(this);
		ButtonPanel.add(OKButton);
		CancelButton = new JButton("Cancel");
		CancelButton.addActionListener(this);
		ButtonPanel.add(CancelButton);
	
		GIP	= new GetImagePanel[NumOfImages];
		
		for (int i = 0; i < NumOfImages; i++) {
			GIP[i] = new GetImagePanel();
			EnterPanel.add(GIP[i]);
		}
	
		EnterPanel.add(ButtonPanel);
		JScrollPane ScrollableEnterPanel = new JScrollPane(EnterPanel);
  
		EnterFrame = new JFrame();
		EnterFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		EnterFrame.getContentPane().add(ScrollableEnterPanel, BorderLayout.CENTER);
		EnterFrame.pack();	
	
		EnterFrame.setVisible(true);
	}
	
	/* Moves a file from one place to another */
	public static void copy(File source, File dest) throws IOException {
		 FileChannel in = null, out = null;
		 try {          
			in = new FileInputStream(source).getChannel();
			out = new FileOutputStream(dest).getChannel();
			in.transferTo( 0, in.size(), out);	
		 } finally {
			  if (in != null)      in.close();
			  if (out != null)     out.close();
		 }
	}
	
	/* We want the new images moved into their own directory */
	public void actionPerformed(ActionEvent e) {
		String ImageLocation;
		File DestFile;
		int counter = 0;
		if (e.getSource() == OKButton) {
			String[] ImagePaths = new String[GIP.length + 1];
			ImagePaths[0] = TitleTE.getText();
			ImageLocation = MainDisplay.getImageLocation();
			File dir = new File(ImageLocation);
    		String[] children = dir.list();
    		
    		/* Looks for a directory that hasn't been used yet */
			for (int i = 0; i < children.length; i++) {
				if (children[i].equals("images" + counter++)) {
					counter++;
					break;
				}
			}
		
    		if (counter > 0) counter--;
    		
			ImageLocation += "images" + counter + File.separator;
			boolean success = (new File(ImageLocation)).mkdir();
    		if (!success) {
       			System.out.println("Could not create directory for images");
       		}
       		
    		try {
				for (int i = 1; i < GIP.length + 1; i++) {
					DestFile = new File(ImageLocation + GIP[i - 1].getSelectedFile().getName());
					copy(GIP[i - 1].getSelectedFile(), DestFile);
					ImagePaths[i] = DestFile.getPath();
				}
			} catch (IOException ioe) {
				System.out.println("Problem moving images");
			}
			MainDisplay.addImageFiles(ImagePaths);
			EnterFrame.setVisible(false);
			EnterFrame.dispose();
		}
		
		if (e.getSource() == CancelButton) {
			EnterFrame.setVisible(false);
			EnterFrame.dispose();
		}		
	} 
}