import java.util.Random;
import java.util.Date;

/* This generates a grid of numbers, from which some can be removed to leave a puzzle */
public class GenerateGrid {

	static int[] Position;			
	
	static int Size;
						
	/* This checks the grid is legitimate. The method is to look for the number of times that the number
	in a square appears in the column, row, and group that contains that square. It should appear three
	times, any more and there is a problem */
	private static boolean checkOK(int i) {
		int Row;
		int Column;
		int Group;
		int Count = 0;
		
		Row = i / PuzzleArrays.RowLength[Size];
		Column = i % PuzzleArrays.RowLength[Size];
		Group = PuzzleArrays.GroupID[Size][i];
		
		
		for (int j = 0; j < PuzzleArrays.RowLength[Size]; j++) {
			if (Position[PuzzleArrays.Rows[Size][Row][j]] == Position[i]) Count++;
			if (Position[PuzzleArrays.Columns[Size][Column][j]] == Position[i]) Count++;
			if (Position[PuzzleArrays.Groups[Size][Group][j]] == Position[i]) Count++;
		}
		if (Count >= 4) {
			return false;
		} else {
			return true;
		}
	}		
	
	private static boolean attemptsLeft(boolean[] a) {
		for (int i = 1; i < a.length; i++) {
			if (!a[i]) {return true;}
		}
		return false;
	}
			 
	/* This generates a grid by adding random numbers to each square in turn and checking the result is
	OK if it isn't try another random number. After ten goes at a square give up and go back to the square
	before */
	public static int[] getFullGrid(int I) {
		Size = I;
		Random R = new Random();
		Position = new int[PuzzleArrays.Sizes[Size]];
		boolean attempts[] = new boolean[PuzzleArrays.NumberOfDigits[Size] + 1];
		int LastInvalid = 0;
		int GoBack = 0;
		int i = 0;
		
		for (i = 0; i < PuzzleArrays.Sizes[Size]; i++) {
			Position[i] = 0;
		}
		
	
		i = 0;
		while (i < PuzzleArrays.Sizes[Size]) {
			for (int j = 1; j < (PuzzleArrays.NumberOfDigits[Size] + 1); j++) {
				attempts[j] = false;
			}
			/* Try to fill the square */
			do {
				Position[i] = R.nextInt(PuzzleArrays.NumberOfDigits[Size]) + 1;
				attempts[Position[i]] = true;
			}
			while (!checkOK(i) && attemptsLeft(attempts));
			if (!checkOK(i)) {
				/* Can't fill the square so go back */
				LastInvalid = i;
				i -= (1 + GoBack);
				if (i < 0) {
					i = 0;
					GoBack = 0;
				}
				for (int j = i; j < PuzzleArrays.Sizes[Size]; j++) {
					Position[j] = 0;
				}
				GoBack++;
			} else {
				if (i > LastInvalid) {
					GoBack = 0;
				}
				i++;
			}
		}
		
		return Position;
	}
}