import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.File;
import javax.swing.*;

/* This just shows a bit of text about how the program works */
public class HelpScreen {
	public HelpScreen() {
		JPanel MainPanel = new JPanel(new GridLayout(1,1));
		JEditorPane HelpTA;
		try {
		/* JEditorPane allows me to use html and get prettier formatting */
		HelpTA = new JEditorPane("text/html","<h2>Help</h2><br>"+
"<u>Short Introduction</u><br>"+
"When you start ASudoku you will be in Input mode. In this mode you can input a puzzle, either through File->Open, or by clicking on the squares and typing the numbers. Once the puzzle has been input clicking \"Finish Setup\" will send you into Solve mode. In this mode you can input your choices by clicking on an empty square and entering the number you believe to be correct. At any point you can click the \"Check\" button and correct guesses will be shown in green, and incorrect ones in red. You can also press the \"Clear\" button to go back to the beginning, and \"Solve\" to have the program solve the puzzle for you.<br><br>"+

"<u>Modes</u><br>"+
"The Input and Solve mode have been described in the Short Introduction. The third mode is the Generate mode. This allows new puzzles to be generated with as much or as little user input as you like. The simplest way to create a puzzle is to select the difficulty you would like, easy, medium, or hard and then press \"Generate Puzzle\" and a puzzle will be automatically generated. The next easiest way is to start with a full grid of numbers, by pressing the \"Generate Grid\" button and then removing some to leave a puzzle. The hardest method is to start from a blank grid and do it all by hand. At any point you can press the \"Check OK\" button to check that you have a valid puzzle. Once the puzzle is to your liking press \"Finish Generation\" to complete the creation of your puzzle.<br><br>"+

"<u>Screen Elements</u><br>"+
"The top element is the menu, the main left hand element is the puzzle itself and the right hand element is the buttons that are valid for the mode you are in. The bottom part of the screen is split into two parts, the left hand side shows the current mode, and the right hand side shows what images are currently in use, and what key they are bound to.<br><br>"+

"<u>Other Features</u><br>"+
"By selecting a square and then right clicking on it it is possible to bring up the notes for that square. These notes can be anything you like that will help you solve the puzzle.<br><br>"+

"<h3>Menus</h3><br>"+

"<u>File</u><br>"+
"<u>Open</u><br>"+
"This allows you to open a previously saved file containing a puzzle. If it is one that has been partially completed you will be asked if you want to start from where you left off, or start afresh.<br><br>"+

"<u>Print</u><br>"+
"This allows you to print out a puzzle, along with some, all, or none of the associated data.<br><br>"+

"<u>Save</u><br>"+
"This allows you to save a puzzle.<br><br>"+

"<u>Quit</u><br>"+
"Does exactly what you would expect.<br><br>"+

"<u>Mode</u><br>"+

"<u>Solve</u><br>"+
"Switches to Solve mode.<br><br>"+

"<u>Input</u><br>"+
"Switches to Input mode.<br><br>"+

"<u>Generate</u><br>"+
"Switches to Generate mode.<br><br>"+

"<u>Options</u><br><br>"+

"<u>Images</u><br><br>"+
"This allows you to change the set of images that are used to any that contain enough images for the type of puzzle you are doing.<br><br>"+

"<u>Puzzle Types</u><br>"+
"This allows you to select between puzzle types. 3x3 is classic Sudoku, while 2x2, 4x4, 5x5 and 4x2 are also available. If thn current images are not suitable for that size of puzzle you will be asked to choose a better set.<br><br>"+

"<u>More Options</u><br>"+
"Generate symmetrical solutions<br><br>"+
"Use X-Axis symmetry<br>"+
"Use Y-Axis symmetry<br>"+
"Some people prefer symmetrical Sudoku puzzles. These options allow them to automatically generate these types of puzzle.<br><br>"+

"<u>Use full solution check</u><br>"+
"By default the program doesn't try to exhaustively solve puzzles because of the time this would take, particularly with the bigger sizes of puzzle. Checking this box does an exhaustive search, but I would not recommend it because a puzzle that tough would be almost impossible to solve by a human.<br><br>"+

"<u>Add new images</u><br>"+
"If you do not like the images provided (and I admit that my artistic talents are not great) you can add your own. These should include a blank image, and should be in gif format. I would also recommend making part of the image transparent so that the colours of blue for selected, green for correct and red for incorrect can be seen.<br><br>"+

"<u>Database</u><br>"+
"A very basic database is provided, which allows puzzles to be added and imported from another database. The database can also be loaded, saved and viewed. When in the view mode double-clicking on an entry loads it and clicking delete removes it from the database.<br><br>"+

"<u>Help</u><br>"+
"ASudoku Help<br>"+
"This shows this help text<br><br>"+

"<u>About</u><br>"+
"This shows the version of this program.");
		HelpTA.setEditable(false);
		JScrollPane editorScrollPane = new JScrollPane(HelpTA);
		editorScrollPane.setVerticalScrollBarPolicy(
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		editorScrollPane.setPreferredSize(new Dimension(500, 300));
		editorScrollPane.setMinimumSize(new Dimension(10, 10));

		MainPanel.add(editorScrollPane);
	
		} catch (Exception e) {
			System.out.println("exception");
		}
		
		JFrame HFrame = new JFrame();
		HFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		HFrame.getContentPane().add(MainPanel, BorderLayout.CENTER);
		HFrame.pack();	
	
		HFrame.setVisible(true);	
	}
}