import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

/* This panel displays the images that are currently in use and the keys bound to them */
public class IndexPanel extends JPanel {
	DigitPanel[] Digits;
	JLabel[] Labels;
	
	public void updateImages(int Size) {
		removeAll();
		/* Limit each row of images to 10 */
		if (Size > 10) {
			setLayout(new GridLayout((Size / 10) + 1, 20));
		} else {
			setLayout(new GridLayout(1, 20));
		}
		Update(Size);
		repaint();
	}
	
	private void Update(int Size) {
		Digits = new DigitPanel[Size];
		Labels = new JLabel[Size];
		
		
		for (int i = 0; i < Size; i++) {
			Digits[i] = new DigitPanel(i + 1, 15, true);
			Digits[i].setCaption(i + 1);
			Labels[i] = new JLabel(new Character(Keys.Keys[i + 1]).toString(), SwingConstants.RIGHT);
			add(Labels[i]);
			add(Digits[i]);
		}
		/* Fills up multirows to sort out formatting issues. */
		if (Size > 10) {
			JLabel[] Filler = new JLabel[(Size * 2) % 20];
			for (int i = 0; i < Filler.length; i++) {
				Filler[i] = new JLabel();
				add(Filler[i]);	
			}
		}
	}
	
	public IndexPanel() {
		super();
		setLayout(new GridLayout(1, 20));
		int Size = 9;
		Update(Size);
	}
}