import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

/* Allows various options to be set */
public class OptionScreen implements ActionListener {
	static boolean UseSymmetry = false;
	static boolean CompleteSolve = false;
	static boolean XAxis = false;
	static boolean YAxis = false;
	
	JCheckBox SymmetryCB;
	JCheckBox XAxisCB;
	JCheckBox YAxisCB;
	JCheckBox SolveCB;
	JButton OKButton;
	JButton CancelButton;
	JButton AddImages;
	JFrame OptionFrame;
	Display MainDisplay;
	
	public OptionScreen(Display D) {
		super();
		MainDisplay = D;
		OptionFrame = new JFrame();
	
		JPanel OptionPanel = new JPanel();
		OptionPanel.setLayout(new BoxLayout(OptionPanel, BoxLayout.Y_AXIS));
		
		JPanel ButtonPanel = new JPanel();
		ButtonPanel.setLayout(new BoxLayout(ButtonPanel, BoxLayout.X_AXIS));
		OKButton = new JButton("OK");
		OKButton.addActionListener(this);
		ButtonPanel.add(OKButton);
		CancelButton = new JButton("Cancel");
		CancelButton.addActionListener(this);
		ButtonPanel.add(CancelButton);
		
		SymmetryCB = new JCheckBox("Generate symmetrical solutions", UseSymmetry);
		XAxisCB = new JCheckBox("Use X-Axis symmetry", XAxis);
		YAxisCB = new JCheckBox("Use Y-Axis symmetry", YAxis);
		SolveCB = new JCheckBox("Use full solution check. (Warning: This can make some operations very slow)", CompleteSolve);
		
		AddImages = new JButton("Add new images");
		AddImages.addActionListener(this);
		
		OptionPanel.add(SymmetryCB);
		OptionPanel.add(XAxisCB);
		OptionPanel.add(YAxisCB);
		OptionPanel.add(SolveCB);
		OptionPanel.add(AddImages);
		OptionPanel.add(ButtonPanel);
		
		OptionFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		OptionFrame.getContentPane().add(OptionPanel, BorderLayout.CENTER);
		OptionFrame.pack();	
	
		OptionFrame.setVisible(true);
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == OKButton) {
			UseSymmetry = SymmetryCB.isSelected();
			CompleteSolve = SolveCB.isSelected();
			XAxis = XAxisCB.isSelected();
			YAxis = YAxisCB.isSelected();
			MainDisplay.saveConfig();
			OptionFrame.setVisible(false);
			OptionFrame.dispose();
		}
		
		if (e.getSource() == CancelButton) {
			OptionFrame.setVisible(false);
			OptionFrame.dispose();
		}
		
		if (e.getSource() == AddImages) {
			String s = (String)JOptionPane.showInputDialog(
                    OptionFrame,
                    "How many images do you want to add?",
                    "Number of Images",
                    JOptionPane.PLAIN_MESSAGE);

			if ((s != null) && (s.length() > 0)) {
				try {
					EnterImages EI = new EnterImages(Integer.parseInt(s), MainDisplay);
				} catch (Exception except) {
				}
			}
		}
	} 
	
	public static boolean getUseSymmetry() {
		return UseSymmetry;
	}
	
	public static boolean getCompleteSolve() {
		return CompleteSolve;
	}
	
	public static boolean getXAxis() {
		return XAxis;
	}
	
	public static boolean getYAxis() {
		return YAxis;
	}
}