import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.print.*;

/* This sets up a panel containing all the selected data */
public class PrintLayoutPanel extends JPanel implements Printable {
	public PrintLayoutPanel(boolean IncludeSolution, boolean IncludeDifficulty,
							boolean IncludeSource, boolean IncludeAuthor,
							boolean IncludeCreationDate, boolean IncludeType,
							boolean IncludeSourceDate, boolean IncludeAttempted,
							Puzzle PrintPuzzle) {
							
			setBackground(Color.white);
			int[] PuzzleLayout = new int[PuzzleArrays.Sizes[PrintPuzzle.getGridType()]];
			int[] TempPuzzle;
			int[] TempAttempted;
			TempPuzzle = PrintPuzzle.getPuzzle();
			TempAttempted = PrintPuzzle.getAttempted();
			for (int i = 0; i < PuzzleArrays.Sizes[PrintPuzzle.getGridType()]; i++) {
				PuzzleLayout[i] = TempPuzzle[i];
			}
			
			if (IncludeAttempted) {
				for (int i = 0; i < PuzzleArrays.Sizes[PrintPuzzle.getGridType()]; i++) {
					PuzzleLayout[i] = TempAttempted[i];
				}
			}
			
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			
			PuzzlePanel PuzzlePanel = new PuzzlePanel(PuzzleLayout, PrintPuzzle.getGridType(), true);
			PuzzlePanel.setBackground(Color.white);
			PuzzlePanel SolutionPanel = new PuzzlePanel(PrintPuzzle.getSolution(), PrintPuzzle.getGridType(), true);
			SolutionPanel.setBackground(Color.white);
			JLabel Difficulty = new JLabel(PrintPuzzle.getDifficulty());
			JLabel Source = new JLabel(PrintPuzzle.getSource());
			JLabel Author = new JLabel(PrintPuzzle.getAuthor());
			JLabel CreationDate = new JLabel(PrintPuzzle.getCreationDate());
			JLabel Type = new JLabel(PrintPuzzle.getType());
			JLabel SourceDate = new JLabel(PrintPuzzle.getSourceDate());
			
			JLabel DifficultyLabel = new JLabel("Difficulty");
			JLabel SourceLabel = new JLabel("Source");
			JLabel AuthorLabel = new JLabel("Author");
			JLabel CreationDateLabel = new JLabel("Creation Date");
			JLabel TypeLabel = new JLabel("Type");
			JLabel SourceDateLabel = new JLabel("Source Date");
			
			JPanel DifficultyPanel = new JPanel();
			DifficultyPanel.setLayout(new GridLayout(1,2));
			DifficultyPanel.setBackground(Color.white);
			JPanel SourcePanel = new JPanel();
			SourcePanel.setLayout(new GridLayout(1,2));
			SourcePanel.setBackground(Color.white);
			JPanel AuthorPanel = new JPanel();
			AuthorPanel.setLayout(new GridLayout(1,2));
			AuthorPanel.setBackground(Color.white);
			JPanel CreationDatePanel = new JPanel();
			CreationDatePanel.setLayout(new GridLayout(1,2));
			CreationDatePanel.setBackground(Color.white);
			JPanel SourceDatePanel = new JPanel();
			SourceDatePanel.setLayout(new GridLayout(1,2));
			SourceDatePanel.setBackground(Color.white);
			JPanel TypePanel = new JPanel();
			TypePanel.setLayout(new GridLayout(1,2));
			TypePanel.setBackground(Color.white);
			
			DifficultyPanel.add(DifficultyLabel);
			DifficultyPanel.add(Difficulty);
			SourcePanel.add(SourceLabel);
			SourcePanel.add(Source);
			AuthorPanel.add(AuthorLabel);
			AuthorPanel.add(Author);
			CreationDatePanel.add(CreationDateLabel);
			CreationDatePanel.add(CreationDate);
			SourceDatePanel.add(SourceDateLabel);
			SourceDatePanel.add(SourceDate);
			TypePanel.add(TypeLabel);
			TypePanel.add(Type);
			
			JPanel TopPanel = new JPanel();
			if (IncludeDifficulty && IncludeAuthor) {
				TopPanel.setLayout(new GridLayout(1,2));
			}
			if (IncludeDifficulty) {
				TopPanel.add(DifficultyPanel);
			}
			if (IncludeAuthor) {
				TopPanel.add(AuthorPanel);
			}
			add(TopPanel);
			add(PuzzlePanel);
			
			JPanel UpperMiddlePanel = new JPanel();
			if (IncludeType && IncludeCreationDate) {
				UpperMiddlePanel.setLayout(new GridLayout(1,2));
			}
			UpperMiddlePanel.setBackground(Color.white);
			if (IncludeType) {
				UpperMiddlePanel.add(TypePanel);
			}
			if (IncludeCreationDate) {
				UpperMiddlePanel.add(CreationDatePanel);
			}
			
			add(UpperMiddlePanel);
			
			JPanel LowerMiddlePanel = new JPanel();
			if (IncludeSource && IncludeSourceDate) {
				LowerMiddlePanel.setLayout(new GridLayout(1,2));
			}
			LowerMiddlePanel.setBackground(Color.white);
			if (IncludeSource) {
				LowerMiddlePanel.add(SourcePanel);
			}
			if (IncludeSourceDate) {
				LowerMiddlePanel.add(SourceDatePanel);
			}
			
			add(LowerMiddlePanel);
			
			if (IncludeSolution) {
				add(SolutionPanel);
			}
	}	

/* Bangs it out to the printer */
  public void print() {
    PrinterJob printJob = PrinterJob.getPrinterJob();
    printJob.setPrintable(this);
    if (printJob.printDialog())
      try {
        printJob.print();
      } catch(PrinterException pe) {
        System.out.println("Error printing: " + pe);
      }
  }

/* Standard from a website somewhere */
  public int print(Graphics g, PageFormat pageFormat, int pageIndex) {
    if (pageIndex > 0) {
      return(NO_SUCH_PAGE);
    } else {
      Graphics2D g2d = (Graphics2D)g;
      g2d.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
      disableDoubleBuffering(this);
      paint(g2d);
      enableDoubleBuffering(this);
      return(PAGE_EXISTS);
    }
  }

/* Double buffering apparently reduces the quality of the output. */
  public static void disableDoubleBuffering(Component c) {
    RepaintManager currentManager = RepaintManager.currentManager(c);
    currentManager.setDoubleBufferingEnabled(false);
  }

  public static void enableDoubleBuffering(Component c) {
    RepaintManager currentManager = RepaintManager.currentManager(c);
    currentManager.setDoubleBufferingEnabled(true);
  }
}