import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

/* This allows the user to select what will be printed */
public class PrintOptions implements ActionListener {
	JFrame printFrame;
	JPanel printPanel;
	JCheckBox IncludeSolutionCB;
	JCheckBox IncludeDifficultyCB;
	JCheckBox IncludeSourceCB;
	JCheckBox IncludeAuthorCB;
	JCheckBox IncludeCreationDateCB;
	JCheckBox IncludeTypeCB;
	JCheckBox IncludeSourceDateCB;
	JCheckBox IncludeAttemptedCB;
	JButton PrintButton;
	JButton CancelButton;
	JPanel ButtonPanel;
	Puzzle PrintPuzzle;
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == PrintButton) {
			PrintFrame PF = new PrintFrame(IncludeSolutionCB.isSelected(),
									IncludeDifficultyCB.isSelected(),
									IncludeSourceCB.isSelected(),
									IncludeAuthorCB.isSelected(),
									IncludeCreationDateCB.isSelected(),
									IncludeTypeCB.isSelected(),
									IncludeSourceDateCB.isSelected(),
									IncludeAttemptedCB.isSelected(),
									PrintPuzzle);
			printFrame.setVisible(false);
			printFrame.dispose();
		}
		if (e.getSource() == CancelButton) {
			printFrame.setVisible(false);
			printFrame.dispose();
		}
	}
	
	public PrintOptions(Puzzle PP) {	
		PrintPuzzle = PP;
		printFrame = new JFrame();
		printPanel = new JPanel();
		printPanel.setLayout(new BoxLayout(printPanel, BoxLayout.Y_AXIS));
		ButtonPanel = new JPanel();
		ButtonPanel.setLayout(new BoxLayout(ButtonPanel, BoxLayout.X_AXIS));
		IncludeSolutionCB = new JCheckBox("Include Solution");
		IncludeDifficultyCB = new JCheckBox("Include Difficulty");
		IncludeSourceCB = new JCheckBox("Include Source");
		IncludeAuthorCB = new JCheckBox("Include Author");
		IncludeCreationDateCB = new JCheckBox("Include Creation Date");
		IncludeTypeCB = new JCheckBox("Include Type");
		IncludeSourceDateCB = new JCheckBox("Include Source Date");
		IncludeAttemptedCB = new JCheckBox("Include Attempted Solution");
		PrintButton = new JButton("Print");
		CancelButton = new JButton("Cancel");
		PrintButton.addActionListener(this);
		CancelButton.addActionListener(this);
		
		ButtonPanel.add(PrintButton);
		ButtonPanel.add(CancelButton);
		
		printPanel.add(IncludeSolutionCB);
		printPanel.add(IncludeDifficultyCB);
		printPanel.add(IncludeSourceCB);
		printPanel.add(IncludeAuthorCB);
		printPanel.add(IncludeCreationDateCB);
		printPanel.add(IncludeTypeCB);
		printPanel.add(IncludeSourceDateCB);
		printPanel.add(IncludeAttemptedCB);
		printPanel.add(ButtonPanel);
		
		printFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		printFrame.getContentPane().add(printPanel, BorderLayout.CENTER);
		printFrame.pack();	
	
		printFrame.setVisible(true);	
	}
}