import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.util.*;
import java.io.*;

/* This allows the current puzzle to be saved, along with all of it's metadata */
public class SaveOptions implements ActionListener {
	JFrame SaveFrame;
	JPanel SavePanel;
	JLabel AuthorLabel;
	JLabel SourceLabel;
	JLabel CreationDateLabel;
	JLabel SourceDateLabel;
	JLabel DifficultyLabel;

	JButton SaveButton;
	JButton CancelButton;
	JTextField AuthorTF;
	JTextField SourceTF;
	JTextField CreationDateTF;
	JTextField SourceDateTF;
	Puzzle SavePuzzle;
	
	JPanel AuthorPanel;
	JPanel SourcePanel;
	JPanel CreationDatePanel;
	JPanel SourceDatePanel;
	JPanel ButtonPanel;
	JPanel DifficultyPanel;
	JComboBox DifficultyLevel;
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == SaveButton) {
			JFileChooser chooser = new JFileChooser();
			SudokuFileFilter filter = new SudokuFileFilter();
			Object[] options = { "Yes", "No" };

    		chooser.setFileFilter(filter);
   			int option = chooser.showSaveDialog(SaveFrame);
	
			if (option == JFileChooser.APPROVE_OPTION) {
				File sf = chooser.getSelectedFile();
				SavePuzzle.setAuthor(AuthorTF.getText());
				SavePuzzle.setSource(SourceTF.getText());
				SavePuzzle.setCreationDate(CreationDateTF.getText());
				SavePuzzle.setSourceDate(SourceDateTF.getText());
				SavePuzzle.setDifficulty((String) DifficultyLevel.getSelectedItem());
				try {
					if (sf.exists()) {
						int i = JOptionPane.showOptionDialog(null, "Do you want to overwrite the existing file?"
													, "Overwrite?", JOptionPane.DEFAULT_OPTION,
													 JOptionPane.QUESTION_MESSAGE, null, options, options[1]);
						if (i == 0) {
							PrintWriter pw = new PrintWriter(new FileWriter(sf, false));
							pw.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			
							SavePuzzle.saveToFile(pw);
					
							pw.flush();
							pw.close();	
						}
					} else {
						PrintWriter pw = new PrintWriter(new FileWriter(sf, false));
						pw.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
						SavePuzzle.saveToFile(pw);
				
						pw.flush();
						pw.close();	
					}
				}
				catch (IOException ioe) {
				}
			}
			SaveFrame.setVisible(false);
			SaveFrame.dispose();
		}
		if (e.getSource() == CancelButton) {
			SaveFrame.setVisible(false);
			SaveFrame.dispose();
		}
	}
	
	public SaveOptions(Puzzle SP) {	
		String[] Levels = {"Easy", "Medium", "Hard"};
		
		SaveFrame = new JFrame();
		SavePanel = new JPanel();
		SavePanel.setLayout(new GridLayout(6,1));
		AuthorPanel = new JPanel();
		AuthorPanel.setLayout(new GridLayout(1,2));
		SourcePanel = new JPanel();
		SourcePanel.setLayout(new GridLayout(1,2));
		CreationDatePanel = new JPanel();
		CreationDatePanel.setLayout(new GridLayout(1,2));
		ButtonPanel = new JPanel();
		ButtonPanel.setLayout(new GridLayout(1,2));
		SourceDatePanel = new JPanel();
		SourceDatePanel.setLayout(new GridLayout(1,2));
		DifficultyPanel = new JPanel();
		DifficultyPanel.setLayout(new GridLayout(1,2));
		
		SavePuzzle = SP;
		AuthorLabel = new JLabel("Author");
		SourceLabel = new JLabel("Source");
		CreationDateLabel = new JLabel("Creation Date");
		SourceDateLabel = new JLabel("Source Date");
		DifficultyLabel = new JLabel("Difficulty");
		SaveButton = new JButton("Save");
		SaveButton.addActionListener(this);
		CancelButton = new JButton("Cancel");
		CancelButton.addActionListener(this);
		AuthorTF = new JTextField(SavePuzzle.getAuthor());
		SourceTF = new JTextField(SavePuzzle.getSource());
		CreationDateTF = new JTextField(SavePuzzle.getCreationDate());
		SourceDateTF = new JTextField(SavePuzzle.getSourceDate());
		DifficultyLevel = new JComboBox(Levels);
		
		AuthorPanel.add(AuthorLabel);
		AuthorPanel.add(AuthorTF);
		
		SourcePanel.add(SourceLabel);
		SourcePanel.add(SourceTF);
		
		CreationDatePanel.add(CreationDateLabel);
		CreationDatePanel.add(CreationDateTF);
		
		SourceDatePanel.add(SourceDateLabel);
		SourceDatePanel.add(SourceDateTF);
		
		ButtonPanel.add(SaveButton);
		ButtonPanel.add(CancelButton);
		
		DifficultyPanel.add(DifficultyLabel);
		DifficultyPanel.add(DifficultyLevel);
		
		SavePanel.add(AuthorPanel);
		SavePanel.add(SourcePanel);
		SavePanel.add(CreationDatePanel);
		SavePanel.add(SourceDatePanel);
		SavePanel.add(DifficultyPanel);
		SavePanel.add(ButtonPanel);
		SaveFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		SaveFrame.getContentPane().add(SavePanel, BorderLayout.CENTER);
		SaveFrame.pack();	
	
		SaveFrame.setVisible(true);	
	}
}