import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import java.util.*;

/* This reads a file of Puzzle in */
public class SudokuHandler extends DefaultHandler {

  private Vector Puzzles = new Vector();
  private boolean inPuzzle = false;
  private boolean inSolution = false;
  private boolean inType = false;
  private boolean inAuthor = false;
  private boolean inSource = false;
  private boolean inCreationDate = false;
  private boolean inDifficulty = false;
  private boolean inAttempted = false;
  private boolean inSourceDate = false;
  private boolean inNotes = false;
  private int X = 0;
  private int Y = 0;
    
  public void startElement(String namespaceURI, String localName,
   String qualifiedName, Attributes atts) throws SAXException {
    if (qualifiedName.equals("Puzzle")) inPuzzle = true;
    if (qualifiedName.equals("Solution")) inSolution = true;
    if (qualifiedName.equals("Type")) inType = true;
    if (qualifiedName.equals("Author")) inAuthor = true;
    if (qualifiedName.equals("Source")) inSource = true;
    if (qualifiedName.equals("CreationDate")) inCreationDate = true;
    if (qualifiedName.equals("Difficulty")) inDifficulty = true;
    if (qualifiedName.equals("Attempted")) inAttempted = true;
    if (qualifiedName.equals("SourceDate")) inSourceDate = true;
    if (qualifiedName.equals("Note")) {
    	inNotes = true;
    	X = Integer.parseInt(atts.getValue("X"));
    	Y = Integer.parseInt(atts.getValue("Y"));
    }
    if (qualifiedName.equals("Sudoku")) {
    	Puzzles.add(new Puzzle());
    };
  }
	
  public Vector getPuzzles() {
  	return Puzzles;
  }
  
  public void endElement(String namespaceURI, String localName,
   String qualifiedName) throws SAXException {

    if (qualifiedName.equals("Puzzle")) inPuzzle = false;
    if (qualifiedName.equals("Solution")) inSolution = false;
    if (qualifiedName.equals("Type")) inType = false;
    if (qualifiedName.equals("Author")) inAuthor = false;
    if (qualifiedName.equals("Source")) inSource = false;
    if (qualifiedName.equals("CreationDate")) inCreationDate = false;
    if (qualifiedName.equals("Difficulty")) inDifficulty = false;    
    if (qualifiedName.equals("Attempted")) inAttempted = false;
    if (qualifiedName.equals("SourceDate")) inSourceDate = false;
    if (qualifiedName.equals("Note")) inNotes = false;
  }

  public void characters(char[] ch, int start, int length)
  throws SAXException {
	String s = "";
	if (inPuzzle) {
    	for (int i = start; i < start + length; i++) {
    		switch (ch[i]) {
    			case '0':
    			case '1':
    			case '2':
    			case '3':
    			case '4':
    			case '5':
    			case '6':
    			case '7':
    			case '8':
    			case '9':
    			case ' ': s+= ch[i];
    		}
	  	}
	  	try {
			if (!s.equals("")) {
		    		((Puzzle) Puzzles.lastElement()).setPuzzle(s.trim());
			}
    	}
    	catch (InvalidPuzzleError ipe) {
    		throw new SAXException("Puzzle has wrong length");
    	}
    }   
	if (inSolution) {
    	for (int i = start; i < start + length; i++) {
    		switch (ch[i]) {
    			case '0':
    			case '1':
    			case '2':
    			case '3':
    			case '4':
    			case '5':
    			case '6':
    			case '7':
    			case '8':
    			case '9':
    			case ' ': s+= ch[i];
    		}
	  	}
	if (!s.equals("")) {
    		((Puzzle) Puzzles.lastElement()).setSolution(s.trim());
	}
    }   
	if (inAttempted) {
    	for (int i = start; i < start + length; i++) {
    		switch (ch[i]) {
    			case '0':
    			case '1':
    			case '2':
    			case '3':
    			case '4':
    			case '5':
    			case '6':
    			case '7':
    			case '8':
    			case '9':
    			case ' ': s+= ch[i];
    		}
	  	}
	if (!s.equals("")) {
    		((Puzzle) Puzzles.lastElement()).setAttempted(s.trim());
	}
    }       
    if (inSourceDate) {
   		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setSourceDate(s.trim());
	}
    }
   	if (inType) {
   		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setType(s.trim());
	}
    }
   	
   	if (inAuthor) {
   		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setAuthor(s.trim());
	}
    }
   	
   	if (inSource) {
   		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setSource(s.trim());
	}
    }
   	
   	if (inCreationDate) {
   		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setCreationDate(s.trim());
	}
    }
   	
   	if (inDifficulty) {
   		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setDifficulty(s.trim());
	}
    }
  	if (inNotes) {
  		for (int i = start; i < start + length; i++) {
   			s += ch[i];
   		}
	if (!s.equals("")) {
   		((Puzzle) Puzzles.lastElement()).setNotes(X, Y, s.trim());
	}
   } 
  }
  
}
